commit 7d3ae877c99f99e2a6eebb9acde800a70aa703b8
Author: freddy77 <freddy77>
Date:   Thu Aug 20 18:59:29 2009 +0000

    fix N(VAR)CHAR inside variant

diff --git a/ChangeLog b/ChangeLog
index 2269500..d7775e9 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Aug 20 20:59:22 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/odbc/unittests/data.c:
+	* src/tds/token.c:
+	- fix N(VAR)CHAR inside variant
+
 Thu Aug 20 19:52:58 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/iconv.c src/tds/token.c:
 	- pass raw collation structure to tds_iconv_from_collate
@@ -1765,4 +1770,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2852 2009/08/20 17:53:06 freddy77 Exp $
+$Id: ChangeLog,v 1.2853 2009/08/20 18:59:29 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 750d3b5..8160f4a 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.64 2009/06/12 08:53:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.65 2009/08/20 18:59:29 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -154,8 +154,11 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	assert(desttype != SQL_C_DEFAULT);
 
 	if (curcol) {
-		if (is_blob_col(curcol) && curcol->column_type != SYBVARIANT)
+		if (is_blob_col(curcol)) {
+			if (curcol->column_type == SYBVARIANT)
+				srctype = ((TDSVARIANT *) src)->type;
 			src = ((TDSBLOB *) src)->textvalue;
+		}
 		if (is_variable_type(curcol->column_type)) {
 			src += curcol->column_text_sqlgetdatapos;
 			srclen -= curcol->column_text_sqlgetdatapos;
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 3e957dd..d811938 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.29 2009/08/19 11:47:52 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.30 2009/08/20 18:59:29 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -182,7 +182,10 @@ main(int argc, char *argv[])
 
 	if (db_is_microsoft() && db_version_int() >= 0x08000000u) {
 		Test("SQL_VARIANT", "CAST('123' AS INT)", SQL_C_CHAR, "3 123");
+		Test("SQL_VARIANT", "CAST('hello' AS CHAR(6))", SQL_C_CHAR, "6 hello ");
 		Test("SQL_VARIANT", "CAST('ciao' AS VARCHAR(10))", SQL_C_CHAR, "4 ciao");
+		Test("SQL_VARIANT", "CAST('foo' AS NVARCHAR(10))", SQL_C_CHAR, "3 foo");
+		Test("SQL_VARIANT", "CAST('Super' AS NCHAR(8))", SQL_C_CHAR, "8 Super   ");
 		Test("SQL_VARIANT", "CAST('321' AS VARBINARY(10))", SQL_C_CHAR, "6 333231");
 		Test("SQL_VARIANT", "CAST('-123.4' AS FLOAT)", SQL_C_CHAR, "6 -123.4");
 		Test("SQL_VARIANT", "CAST('-123.4' AS NUMERIC(10,2))", SQL_C_CHAR, "7 -123.40");
diff --git a/src/tds/token.c b/src/tds/token.c
index 3cb854b..680b740 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.370 2009/08/20 17:53:06 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.371 2009/08/20 18:59:29 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -2009,8 +2009,8 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		tds_get_n(tds, v->collation, sizeof(v->collation));
 		colsize -= sizeof(v->collation);
 		info_len -= sizeof(v->collation);
-		curcol->char_conv =
-			tds_iconv_from_collate(tds, v->collation);
+		curcol->char_conv = is_unicode_type(type) ? 
+			tds->char_convs[client2ucs2] : tds_iconv_from_collate(tds, v->collation);
 	}
 	/* special case for numeric */
 	if (is_numeric_type(type)) {

